Index: trunk/include/VBox/vmm/apic.h
===================================================================
--- trunk/include/VBox/vmm/apic.h	(revision 82817)
+++ trunk/include/VBox/vmm/apic.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/cfgm.h
===================================================================
--- trunk/include/VBox/vmm/cfgm.h	(revision 82817)
+++ trunk/include/VBox/vmm/cfgm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/cpum.h
===================================================================
--- trunk/include/VBox/vmm/cpum.h	(revision 82817)
+++ trunk/include/VBox/vmm/cpum.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/cpum.mac
===================================================================
--- trunk/include/VBox/vmm/cpum.mac	(revision 82817)
+++ trunk/include/VBox/vmm/cpum.mac	(revision 82968)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2019 Oracle Corporation
+; Copyright (C) 2006-2020 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/cpumctx-v1_6.h
===================================================================
--- trunk/include/VBox/vmm/cpumctx-v1_6.h	(revision 82817)
+++ trunk/include/VBox/vmm/cpumctx-v1_6.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/cpumctx.h
===================================================================
--- trunk/include/VBox/vmm/cpumctx.h	(revision 82817)
+++ trunk/include/VBox/vmm/cpumctx.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/cpumdis.h
===================================================================
--- trunk/include/VBox/vmm/cpumdis.h	(revision 82817)
+++ trunk/include/VBox/vmm/cpumdis.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/dbgf.h
===================================================================
--- trunk/include/VBox/vmm/dbgf.h	(revision 82817)
+++ trunk/include/VBox/vmm/dbgf.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/dbgfcorefmt.h
===================================================================
--- trunk/include/VBox/vmm/dbgfcorefmt.h	(revision 82817)
+++ trunk/include/VBox/vmm/dbgfcorefmt.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2010-2019 Oracle Corporation
+ * Copyright (C) 2010-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/dbgfsel.h
===================================================================
--- trunk/include/VBox/vmm/dbgfsel.h	(revision 82817)
+++ trunk/include/VBox/vmm/dbgfsel.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/dbgftrace.h
===================================================================
--- trunk/include/VBox/vmm/dbgftrace.h	(revision 82817)
+++ trunk/include/VBox/vmm/dbgftrace.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/em.h
===================================================================
--- trunk/include/VBox/vmm/em.h	(revision 82817)
+++ trunk/include/VBox/vmm/em.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/gim.h
===================================================================
--- trunk/include/VBox/vmm/gim.h	(revision 82817)
+++ trunk/include/VBox/vmm/gim.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2014-2019 Oracle Corporation
+ * Copyright (C) 2014-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/gmm.h
===================================================================
--- trunk/include/VBox/vmm/gmm.h	(revision 82817)
+++ trunk/include/VBox/vmm/gmm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2007-2019 Oracle Corporation
+ * Copyright (C) 2007-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/gvm.h
===================================================================
--- trunk/include/VBox/vmm/gvm.h	(revision 82817)
+++ trunk/include/VBox/vmm/gvm.h	(revision 82968)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2007-2019 Oracle Corporation
+ * Copyright (C) 2007-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/gvmm.h
===================================================================
--- trunk/include/VBox/vmm/gvmm.h	(revision 82817)
+++ trunk/include/VBox/vmm/gvmm.h	(revision 82968)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2007-2019 Oracle Corporation
+ * Copyright (C) 2007-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/hm.h
===================================================================
--- trunk/include/VBox/vmm/hm.h	(revision 82817)
+++ trunk/include/VBox/vmm/hm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/hm_svm.h
===================================================================
--- trunk/include/VBox/vmm/hm_svm.h	(revision 82817)
+++ trunk/include/VBox/vmm/hm_svm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/hm_vmx.h
===================================================================
--- trunk/include/VBox/vmm/hm_vmx.h	(revision 82817)
+++ trunk/include/VBox/vmm/hm_vmx.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/hm_vmx.mac
===================================================================
--- trunk/include/VBox/vmm/hm_vmx.mac	(revision 82817)
+++ trunk/include/VBox/vmm/hm_vmx.mac	(revision 82968)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2019 Oracle Corporation
+; Copyright (C) 2006-2020 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/hmvmxinline.h
===================================================================
--- trunk/include/VBox/vmm/hmvmxinline.h	(revision 82817)
+++ trunk/include/VBox/vmm/hmvmxinline.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/iem.h
===================================================================
--- trunk/include/VBox/vmm/iem.h	(revision 82817)
+++ trunk/include/VBox/vmm/iem.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2011-2019 Oracle Corporation
+ * Copyright (C) 2011-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/iom.h
===================================================================
--- trunk/include/VBox/vmm/iom.h	(revision 82817)
+++ trunk/include/VBox/vmm/iom.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/mm.h
===================================================================
--- trunk/include/VBox/vmm/mm.h	(revision 82817)
+++ trunk/include/VBox/vmm/mm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/nem.h
===================================================================
--- trunk/include/VBox/vmm/nem.h	(revision 82817)
+++ trunk/include/VBox/vmm/nem.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2018-2019 Oracle Corporation
+ * Copyright (C) 2018-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdm.h
===================================================================
--- trunk/include/VBox/vmm/pdm.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmapi.h
===================================================================
--- trunk/include/VBox/vmm/pdmapi.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmapi.h	(revision 82968)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmasynccompletion.h
===================================================================
--- trunk/include/VBox/vmm/pdmasynccompletion.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmasynccompletion.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2007-2019 Oracle Corporation
+ * Copyright (C) 2007-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmasynctask.h
===================================================================
--- trunk/include/VBox/vmm/pdmasynctask.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmasynctask.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2007-2019 Oracle Corporation
+ * Copyright (C) 2007-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmaudioifs.h
===================================================================
--- trunk/include/VBox/vmm/pdmaudioifs.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmaudioifs.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmblkcache.h
===================================================================
--- trunk/include/VBox/vmm/pdmblkcache.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmblkcache.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2007-2019 Oracle Corporation
+ * Copyright (C) 2007-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmcardreaderinfs.h
===================================================================
--- trunk/include/VBox/vmm/pdmcardreaderinfs.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmcardreaderinfs.h	(revision 82968)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2019 Oracle Corporation
+ * Copyright (C) 2011-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmcommon.h
===================================================================
--- trunk/include/VBox/vmm/pdmcommon.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmcommon.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmcritsect.h
===================================================================
--- trunk/include/VBox/vmm/pdmcritsect.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmcritsect.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmcritsectrw.h
===================================================================
--- trunk/include/VBox/vmm/pdmcritsectrw.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmcritsectrw.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmdev.h
===================================================================
--- trunk/include/VBox/vmm/pdmdev.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmdev.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmdrv.h
===================================================================
--- trunk/include/VBox/vmm/pdmdrv.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmdrv.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmifs.h
===================================================================
--- trunk/include/VBox/vmm/pdmifs.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmifs.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmins.h
===================================================================
--- trunk/include/VBox/vmm/pdmins.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmins.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmnetifs.h
===================================================================
--- trunk/include/VBox/vmm/pdmnetifs.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmnetifs.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmnetinline.h
===================================================================
--- trunk/include/VBox/vmm/pdmnetinline.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmnetinline.h	(revision 82968)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2010-2019 Oracle Corporation
+ * Copyright (C) 2010-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmnetshaper.h
===================================================================
--- trunk/include/VBox/vmm/pdmnetshaper.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmnetshaper.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2011-2019 Oracle Corporation
+ * Copyright (C) 2011-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmnvram.h
===================================================================
--- trunk/include/VBox/vmm/pdmnvram.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmnvram.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2012-2019 Oracle Corporation
+ * Copyright (C) 2012-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmpci.h
===================================================================
--- trunk/include/VBox/vmm/pdmpci.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmpci.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2010-2019 Oracle Corporation
+ * Copyright (C) 2010-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmpcidev.h
===================================================================
--- trunk/include/VBox/vmm/pdmpcidev.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmpcidev.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmpcidevint.h
===================================================================
--- trunk/include/VBox/vmm/pdmpcidevint.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmpcidevint.h	(revision 82968)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmqueue.h
===================================================================
--- trunk/include/VBox/vmm/pdmqueue.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmqueue.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmserialifs.h
===================================================================
--- trunk/include/VBox/vmm/pdmserialifs.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmserialifs.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2018-2019 Oracle Corporation
+ * Copyright (C) 2018-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmsrv.h
===================================================================
--- trunk/include/VBox/vmm/pdmsrv.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmsrv.h	(revision 82968)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmstorageifs.h
===================================================================
--- trunk/include/VBox/vmm/pdmstorageifs.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmstorageifs.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmtask.h
===================================================================
--- trunk/include/VBox/vmm/pdmtask.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmtask.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2019 Oracle Corporation
+ * Copyright (C) 2019-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmthread.h
===================================================================
--- trunk/include/VBox/vmm/pdmthread.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmthread.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmusb.h
===================================================================
--- trunk/include/VBox/vmm/pdmusb.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmusb.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pdmwebcaminfs.h
===================================================================
--- trunk/include/VBox/vmm/pdmwebcaminfs.h	(revision 82817)
+++ trunk/include/VBox/vmm/pdmwebcaminfs.h	(revision 82968)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2019 Oracle Corporation
+ * Copyright (C) 2011-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/pgm.h
===================================================================
--- trunk/include/VBox/vmm/pgm.h	(revision 82817)
+++ trunk/include/VBox/vmm/pgm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/selm.h
===================================================================
--- trunk/include/VBox/vmm/selm.h	(revision 82817)
+++ trunk/include/VBox/vmm/selm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/ssm.h
===================================================================
--- trunk/include/VBox/vmm/ssm.h	(revision 82817)
+++ trunk/include/VBox/vmm/ssm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/stam.h
===================================================================
--- trunk/include/VBox/vmm/stam.h	(revision 82817)
+++ trunk/include/VBox/vmm/stam.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/stam.mac
===================================================================
--- trunk/include/VBox/vmm/stam.mac	(revision 82817)
+++ trunk/include/VBox/vmm/stam.mac	(revision 82968)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2019 Oracle Corporation
+; Copyright (C) 2006-2020 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/tm.h
===================================================================
--- trunk/include/VBox/vmm/tm.h	(revision 82817)
+++ trunk/include/VBox/vmm/tm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/trpm.h
===================================================================
--- trunk/include/VBox/vmm/trpm.h	(revision 82817)
+++ trunk/include/VBox/vmm/trpm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/trpm.mac
===================================================================
--- trunk/include/VBox/vmm/trpm.mac	(revision 82817)
+++ trunk/include/VBox/vmm/trpm.mac	(revision 82968)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2019 Oracle Corporation
+; Copyright (C) 2006-2020 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/uvm.h
===================================================================
--- trunk/include/VBox/vmm/uvm.h	(revision 82817)
+++ trunk/include/VBox/vmm/uvm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2007-2019 Oracle Corporation
+ * Copyright (C) 2007-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/vm.h
===================================================================
--- trunk/include/VBox/vmm/vm.h	(revision 82817)
+++ trunk/include/VBox/vmm/vm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/vm.mac
===================================================================
--- trunk/include/VBox/vmm/vm.mac	(revision 82817)
+++ trunk/include/VBox/vmm/vm.mac	(revision 82968)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2019 Oracle Corporation
+; Copyright (C) 2006-2020 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/vmapi.h
===================================================================
--- trunk/include/VBox/vmm/vmapi.h	(revision 82817)
+++ trunk/include/VBox/vmm/vmapi.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/vmcc.h
===================================================================
--- trunk/include/VBox/vmm/vmcc.h	(revision 82817)
+++ trunk/include/VBox/vmm/vmcc.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2019 Oracle Corporation
+ * Copyright (C) 2019-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/vmcpuset.h
===================================================================
--- trunk/include/VBox/vmm/vmcpuset.h	(revision 82817)
+++ trunk/include/VBox/vmm/vmcpuset.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/include/VBox/vmm/vmm.h
===================================================================
--- trunk/include/VBox/vmm/vmm.h	(revision 82817)
+++ trunk/include/VBox/vmm/vmm.h	(revision 82968)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2019 Oracle Corporation
+ * Copyright (C) 2006-2020 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as