Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp	(revision 83098)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.cpp	(revision 83099)
@@ -31,10 +31,10 @@
 }
 
-QList<UICloudMachine> UITaskCloudAcquireInstances::instances() const
+QList<UICloudMachine> UITaskCloudAcquireInstances::result() const
 {
     m_mutex.lock();
-    const QList<UICloudMachine> instances = m_instances;
+    const QList<UICloudMachine> resultList = m_result;
     m_mutex.unlock();
-    return instances;
+    return resultList;
 }
 
@@ -51,22 +51,20 @@
     m_mutex.lock();
 
-    do
+    /* Gather VM names, ids and states.
+     * Currently we are interested in Running and Stopped VMs only. */
+    CStringArray comNames;
+    CStringArray comIDs;
+    const QVector<KCloudMachineState> cloudMachineStates  = QVector<KCloudMachineState>()
+                                                         << KCloudMachineState_Running
+                                                         << KCloudMachineState_Stopped;
+
+    /* Ask for cloud instance list: */
+    CProgress comProgress = m_comCloudClient.ListInstances(cloudMachineStates, comNames, comIDs);
+    if (!m_comCloudClient.isOk())
     {
-        /* Gather VM names, ids and states.
-         * Currently we are interested in Running and Stopped VMs only. */
-        CStringArray comNames;
-        CStringArray comIDs;
-        const QVector<KCloudMachineState> cloudMachineStates  = QVector<KCloudMachineState>()
-                                                             << KCloudMachineState_Running
-                                                             << KCloudMachineState_Stopped;
-
-        /* Ask for cloud instance list: */
-        CProgress comProgress = m_comCloudClient.ListInstances(cloudMachineStates, comNames, comIDs);
-        if (!m_comCloudClient.isOk())
-        {
-            /// @todo pack error info to m_comErrorInfo
-            break;
-        }
-
+        /// @todo pack error info to m_comErrorInfo
+    }
+    else
+    {
         /* Wait for "Acquire cloud instances" progress: */
         comProgress.WaitForCompletion(-1);
@@ -74,14 +72,14 @@
         {
             /// @todo pack error info to m_comErrorInfo
-            break;
         }
-
-        /* Fetch acquired objects to lists: */
-        const QVector<QString> instanceIds = comIDs.GetValues();
-        const QVector<QString> instanceNames = comNames.GetValues();
-        for (int i = 0; i < instanceIds.size(); ++i)
-            m_instances << UICloudMachine(m_comCloudClient, instanceIds.at(i), instanceNames.at(i));
+        else
+        {
+            /* Fetch acquired objects to lists: */
+            const QVector<QString> instanceIds = comIDs.GetValues();
+            const QVector<QString> instanceNames = comNames.GetValues();
+            for (int i = 0; i < instanceIds.size(); ++i)
+                m_result << UICloudMachine(m_comCloudClient, instanceIds.at(i), instanceNames.at(i));
+        }
     }
-    while (0);
 
     m_mutex.unlock();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h	(revision 83098)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UITaskCloudAcquireInstances.h	(revision 83099)
@@ -55,6 +55,6 @@
     CVirtualBoxErrorInfo errorInfo();
 
-    /** Returns the instance object list. */
-    QList<UICloudMachine> instances() const;
+    /** Returns the task result. */
+    QList<UICloudMachine> result() const;
 
 protected:
@@ -65,5 +65,5 @@
 private:
 
-    /** Holds the mutex to access m_guiMedium member. */
+    /** Holds the mutex to access result. */
     mutable QMutex  m_mutex;
 
@@ -76,6 +76,6 @@
     CVirtualBoxErrorInfo  m_comErrorInfo;
 
-    /** Holds the instance object list. */
-    QList<UICloudMachine>  m_instances;
+    /** Holds the task result. */
+    QList<UICloudMachine>  m_result;
 };
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83098)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 83099)
@@ -301,5 +301,5 @@
     /* Add real cloud VM items: */
     int iPosition = 1; /* we've got item with index 0 already, the "Empty" one .. */
-    foreach (const UICloudMachine &guiCloudMachine, pAcquiringTask->instances())
+    foreach (const UICloudMachine &guiCloudMachine, pAcquiringTask->result())
         new UIChooserNodeMachine(pParentNode,
                                  false /* favorite */,